import java.awt.*;
import java.io.*;
import java.net.*;

public class AtVideo extends Canvas implements Runnable {
// extends AtCams
    private Thread thrd;
	protected String channelName, cIp, ipnPort;
	protected int  nPort = 8080;
    private Image img, offImage;
    private int nDataSize, nOffset;
    private String urlString;
    private Socket sock;
    private Toolkit tk;
    private boolean discrete, smallPic = false, videoFailed = false, imageNew = false;
    private Graphics offGraphics;
	protected Rectangle coords;
	private long delay = 1000;
	
	private boolean debug = false;
	
	AtVideo(){
	}

	AtVideo (String cName, String IP, boolean disflag){
        tk = Toolkit.getDefaultToolkit();
        offImage = createImage(320, 240);
		common(cName, IP, disflag);
	}
	
	AtVideo (String cName, String IP, boolean disflag, boolean picSize, Rectangle rec){
		coords = new Rectangle(rec);
		tk = Toolkit.getDefaultToolkit();
        offImage = createImage(40, 30);
		smallPic = picSize;
		common(cName, IP, true);
	}
	private void common(String cName, String IP, boolean disflag){
		channelName = cName;
		ipnPort = IP;
		cIp = IP.substring(0,IP.indexOf(":"));
		nPort = Integer.parseInt(IP.substring(IP.lastIndexOf(":")+1,IP.length()));
		discrete = disflag;

        nDataSize = 6000;
		videoStart();
	}
	
	public void videoStart(){
		debug(debug,"videoStart");		
        if(thrd == null) {
            thrd = new Thread(this,"AtVideo "+ipnPort+" Room : "+channelName);
            thrd.start();
        }
	}
	
    public void stop() {
		img = null;
		offImage = null;
		
        if(thrd != null)
            thrd = null;
        if(sock != null) {
            try {
                sock.close();
            }
            catch(Exception _ex) { error(1,_ex); }
            sock = null;
        }
    }

    public void run() {
        byte abyte0[] = new byte[nDataSize];
        byte abyte1[] = new byte[nDataSize];
        boolean flag = false;
        img = null;

        if(sock != null)
            try {
                sock.close();
            }
            catch(Exception _ex) { error(2,_ex); }
        sock = null;
		String s;
		if (!smallPic)
//			s = "GET /bigjava.jpg HTTP/1.0\r\nHost: " + cIp + "\r\n\r\n"; //Normal Now fucked
//			s = "GET /medmjava.jpg HTTP/1.0\r\nHost: " + cIp + "\r\n\r\n"; //1/4 size pic, halt
//			s = "GET /micrjava.jpg.jpg HTTP/1.0\r\nHost: " + cIp + "\r\n\r\n"; //1/4 size, halt
//			s = "GET /minijava.jpg.jpg HTTP/1.0\r\nHost: " + cIp + "\r\n\r\n"; //Tumbnail 1/8 size
//			s = "GET /guestvid.jpg HTTP/1.0\r\nHost: " + cIp + "\r\n\r\n"; //Large with large banner
//			s = "GET /guestmed.jpg HTTP/1.0\r\nHost: " + cIp + "\r\n\r\n"; //1/2 size with banner
//			s = "GET /java.jpg HTTP/1.0\r\nHost: " + cIp + "\r\n\r\n"; //Data but no image
			
//			s = "GET /java.jpg?accesscode=lhost_BLAH50_-JOINUS-_5058754_20020311_151002 HTTP/1.0\r\nHost: 192.168.0.54\r\n\r\n";
//			s = "GET /java.jpg?accesscode=lhost_LILHOTIE4U_DARK_EMMA_5073820_20020312_213408v HTTP/1.0\r\nHost: 80.86.102.76\r\n\r\n";
		else
			s = "GET /minijava.jpg HTTP/1.0\r\nHost: " + cIp + "\r\n\r\n";
        String s1;
		if (discrete)
//			s1 = "GET /speed.inf HTTP/1.0\r\nHost: " + cIp + "\r\n\r\n";
			s1 = "GET /speed.ifg HTTP/1.0\r\nHost: " + cIp + "\r\n\r\n"; //Normal
//			s1 = "GET /speed.ifo?accesscode=lhost_LILHOTIE4U_DARK_EMMA_5073820_20020312_213408v HTTP/1.0\r\nHost: 80.86.102.76\r\n\r\n";
				else
			s1 = "GET /speed.iff HTTP/1.0\r\nHost: " + cIp + "\r\n\r\n"; //gives the game away
        while(thrd != null)  {
			if(!connectSocket())
				return;
            if(sock == null)
                break;
            if(thrd == null)
                break;
            PrintWriter printwriter;
            InputStream inputstream;
            try {
                OutputStream outputstream = sock.getOutputStream();
                printwriter = new PrintWriter(new OutputStreamWriter(outputstream));
                inputstream = sock.getInputStream();
                DataInputStream datainputstream = new DataInputStream(new BufferedInputStream(inputstream));
            }
            catch(Exception _ex) {
                try {
                    sock.close();
                    sock = null;
					error(4,_ex);
                }
                catch(Exception _ex2) { error(5,_ex2); }
                continue;
            }
            if(thrd != null && sock != null) {
                try {
                    printwriter.write(s1);
                    printwriter.flush();
                }
                catch(Exception _ex) {
					error(10,_ex);
                }
            }
            while(thrd != null && sock != null)  {
                try {
                    printwriter.write(s);
                    printwriter.flush();
					if (printwriter.checkError())
						break;
					
                    nOffset = 0;
                    do {
                        int j1 = inputstream.read(abyte0, nOffset, nDataSize - nOffset);
                        if(j1 < 0)
                            break;
                        nOffset += j1;
                        if(nOffset >= nDataSize) {
                            nDataSize = nDataSize + 3000;
                            byte abyte4[] = new byte[nDataSize];
                            System.arraycopy(abyte0, 0, abyte4, 0, nOffset);
                            abyte0 = abyte4;
                            abyte4 = null;
                        }
                    } while(abyte0[nOffset - 1] != -39);
                    img = tk.createImage(abyte0);
                    MediaTracker mediatracker = new MediaTracker(this);
                    mediatracker.addImage(img, 1);
                    mediatracker.waitForID(1);
					imageNew = true;
                }
                catch(Exception _ex) {
                    break;
                }
                try {
					if (smallPic)
						Thread.sleep(10000);
					else
						Thread.sleep(delay);
                }
                catch(Exception _ex) { }
            }
            if(sock != null) {
                try {
                    inputstream.close();
                    sock.close();
                }
                catch(Exception _ex) { }
                sock = null;
            }
        }
    }
	
	private int connectFlag = 0;
	
	private boolean connectSocket(){
		connectFlag = 0;
		try {
			sock = new Socket(cIp, nPort);
		}
		catch(Exception _ex) {
//			System.out.println(nPort);
			System.out.println(_ex);
			error(3,_ex);
			}
		if (sock != null){
			connectFlag = 1;
			return true;
		}
		else {
			connectFlag = 2;
			return false;
		}
	}
	private void error(int a, Exception e){
		videoFailed = true;
		System.out.println("Error : AtVideo @ : "+a+" : "+e);
	}
	
	public Image getFrame(){
//		return img;
		if (imageNew){
			imageNew = false;
			return img;
		}
		else return null;
	}
	
	public boolean isConnected(){
		long timeFailure = System.currentTimeMillis()+15000;
		while (connectFlag == 0){
			if (System.currentTimeMillis()>timeFailure)
				break;
			try {Thread.sleep(1000);}
			catch (Exception ex){}
		}
		if (sock!=null)
			return true;
		else
			return false;
		
	}
	
	private void debug(boolean flag,String location){
		if (debug&&flag){
			System.out.println("AtVideo : "+channelName+" : Loc : "+location);
		}
	}
	
	public void setDiscrete(long u_delay){
		delay = u_delay;
	}
	
	public boolean videoFailed(){
		return videoFailed;
	}
}