// NMI's Java Code Viewer 5.1  1997-2001 B. Lemaire
// http://njcv.htmlplanet.com - info@njcv.htmlplanet.com

// Copy registered to Evaluation Copy                                   

// Source File Name:   banapp.java

import java.applet.Applet;
import java.applet.AppletContext;
import java.awt.*;
import java.io.*;
import java.net.*;

public class banapp extends Applet
    implements Runnable {

    Image offImage;
    Font fntSmall;
    Thread thrd;
    Toolkit tk;
    Socket sock;
    Graphics offGraphics;
    final int MAX_IMAGES = 10;
    int nSpeed;
    Image img[];
    int nImgCnt;
    int nMaxImages;
    int nPort;
    String _cIp;
    String cGetDoc;
    String cParamVch;
    String cRoom;
    String cPortal;
    String urlString;
    String cVch;
    int nDataSize;
    OutputStream os;
    PrintWriter pw;
    InputStream is;
    DataInputStream ds;
    String cLog;
    String cTrace;

    public void init() {
        tk = Toolkit.getDefaultToolkit();
        fntSmall = new Font("Helvetica", 1, 10);
        urlString = "http://www.ifriend.net/";
        nPort = (int)(Math.random() * 10D) % 10;
        nPort += 8080;
    }

    public void start() {
        cPortal = getParameter("PortalClickCounterRedirectURL");
        cLog = getParameter("clicklog");
        cTrace = getParameter("trace");
        cParamVch = getParameter("chathost");
        if(cParamVch != null && (cParamVch.length() <= 1 || cParamVch.length() > 15))
            cParamVch = null;
        cRoom = getParameter("room");
        offImage = createImage(40, 30);
        cGetDoc = getDocumentBase().toString();
        String s = getCodeBase().toString().toLowerCase();
        s = s.substring(7);
        int i = s.indexOf('/');
        if(i > 0)
            s = s.substring(0, i);
        _cIp = s;
        if(thrd == null) {
            thrd = new Thread(this);
            thrd.start();
        }
    }

    public void stop() {
        if(thrd != null)
            thrd = null;
        if(sock != null) {
            try {
                sock.close();
            }
            catch(Exception _ex) { }
            sock = null;
        }
    }

    public void update(Graphics g) {
        paint(g);
    }

    public void paint(Graphics g) {
        if(nImgCnt >= 0 && img[nImgCnt] != null) {
            offGraphics = offImage.getGraphics();
            offGraphics.drawImage(img[nImgCnt], 0, 0, 40, 30, this);
            g.drawImage(offImage, 0, 0, this);
            return;
        } else {
            g.setColor(new Color(0, 255, 255));
            g.setFont(fntSmall);
            setBackground(Color.black);
            g.clearRect(0, 0, 40, 30);
            g.drawString("Starting . . .", 1, 20);
            return;
        }
    }

    public void run() {
        int j = 0;
        for(int i = 0; i < 10; i++)
            img[i] = null;

        if(sock != null)
            try {
                sock.close();
            }
            catch(Exception _ex) { }
        sock = null;
        while(thrd != null && j < 30)  {
            j++;
            if(!openSocket() || thrd == null)
                break;
            if(!setStreams() || sock == null)
                continue;
            if(thrd == null)
                break;
            if(getVch()) {
                getVids();
                closeSocket();
                if(nImgCnt >= 2)
                    loopVideo();
            }
        }
    }

    public boolean openSocket() {
        int i;
        for(i = 0; thrd != null && sock == null && i < 30; i++)
            try {
                sock = new Socket(_cIp, nPort);
                if(sock != null)
                    break;
                Thread.sleep(1000L);
            }
            catch(Exception _ex) { }

        return i < 30 && sock != null;
    }

    public boolean setStreams() {
        boolean flag = true;
        try {
            os = sock.getOutputStream();
            pw = new PrintWriter(new OutputStreamWriter(os));
            is = sock.getInputStream();
            ds = new DataInputStream(new BufferedInputStream(is));
        }
        catch(Exception _ex) {
            try {
                sock.close();
                sock = null;
            }
            catch(Exception _ex2) { }
            flag = false;
        }
        return flag;
    }

    public boolean getVch() {
        byte abyte0[] = new byte[nDataSize];
        byte abyte1[] = new byte[nDataSize];
        boolean flag = false;
        boolean flag1 = false;
        if(cVch != null)
            return true;
        if(sock == null)
            return false;
        if(thrd == null)
            return false;
        String s;
        if(cParamVch == null) {
            s = "GET /vch.info?";
            if(cRoom != null)
                s = s + "room=" + cRoom + "&";
            s = s + "doc=" + cGetDoc + " HTTP/1.0\r\n";
        } else {
            s = "GET /" + cParamVch + ".info?";
            if(cRoom != null)
                s = s + "room=" + cRoom + "&";
            s = s + "doc=" + cGetDoc + " HTTP/1.0\r\n";
        }
        cVch = null;
        try {
            pw.write(s);
            pw.flush();
            int k = 0;
            int i = is.read(abyte0, k, nDataSize - k);
            k += i;
            if(k > 2) {
                if(abyte0[k - 2] == 13)
                    k -= 2;
                else
                    k--;
                abyte0[k] = 0;
                byte abyte2[] = new byte[k];
                System.arraycopy(abyte0, 0, abyte2, 0, k);
                cVch = new String(abyte2);
                int j = cVch.indexOf('*');
                if(j > 0) {
                    nMaxImages = Integer.parseInt(cVch.substring(j + 1));
                    cVch = cVch.substring(0, j);
                    flag1 = true;
                }
            }
        }
        catch(Exception _ex) {
            nMaxImages = 0;
        }
        return flag1;
    }

    public void getVids() {
        int k = 0;
        byte abyte0[] = new byte[nDataSize];
        byte abyte1[] = new byte[nDataSize];
        String s;
        if(cParamVch == null)
            s = "GET /image.jpg HTTP/1.0\r\n";
        else
            s = "GET /" + cParamVch + "_image.jpg HTTP/1.0\r\n";
        while(thrd != null && sock != null && nImgCnt < 10 && k < nMaxImages)  {
            try {
                pw.write(s);
                pw.flush();
                int j = 0;
                do {
                    int i = is.read(abyte0, j, nDataSize - j);
                    if(i < 0)
                        break;
                    j += i;
                    if(j >= nDataSize) {
                        nDataSize = nDataSize + 1024;
                        byte abyte2[] = new byte[nDataSize];
                        System.arraycopy(abyte0, 0, abyte2, 0, j);
                        abyte0 = abyte2;
                        abyte2 = null;
                    }
                } while(abyte0[j - 1] != -39);
                nImgCnt++;
                img[nImgCnt] = tk.createImage(abyte0);
                MediaTracker mediatracker = new MediaTracker(this);
                mediatracker.addImage(img[nImgCnt], 1);
                mediatracker.waitForID(1);
                k++;
                repaint();
            }
            catch(Exception _ex) {
                return;
            }
            try {
                Thread.sleep(nSpeed);
            }
            catch(Exception _ex) { }
        }
    }

    public void loopVideo() {
        int i = nImgCnt;
        if(i < 1)
            return;
        nImgCnt = -1;
        while(thrd != null)  {
            nImgCnt++;
            if(nImgCnt > i)
                nImgCnt = 0;
            repaint();
            try {
                Thread.sleep(nSpeed);
            }
            catch(Exception _ex) { }
        }
    }

    public void closeSocket() {
        if(sock == null)
            return;
        try {
            is.close();
            sock.close();
        }
        catch(Exception _ex) { }
        sock = null;
    }

    public banapp() {
        nSpeed = 750;
        img = new Image[10];
        nImgCnt = -1;
        nDataSize = 2048;
    }
}
